"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var createNewAction = function createNewAction(_ref) {
  var action = _ref.action,
      method = _ref.method;

  var newAction = _extends({}, action);
  newAction.method = method;
  delete newAction[method];
  delete newAction.onRequest;
  delete newAction.onResponse;
  delete newAction.onError;
  return newAction;
};

var dispatchDefault = exports.dispatchDefault = function dispatchDefault(_ref2) {
  var type = _ref2.type,
      context = _ref2.context,
      store = _ref2.store,
      method = _ref2.method,
      response = _ref2.response;

  if (type) {
    store.dispatch({ type: type, context: context, response: response, method: method });
  }
};

var dispatchOnRequest = exports.dispatchOnRequest = function dispatchOnRequest(_ref3) {
  var action = _ref3.action,
      store = _ref3.store,
      method = _ref3.method;

  if (action.onRequest) {
    var newAction = createNewAction({ action: action, method: method });
    newAction.type = action.onRequest;
    store.dispatch(newAction);
  }
};

var dispatchOnResponse = exports.dispatchOnResponse = function dispatchOnResponse(_ref4) {
  var action = _ref4.action,
      store = _ref4.store,
      response = _ref4.response,
      method = _ref4.method;

  if (action.onResponse) {
    var newAction = createNewAction({ action: action, method: method });
    newAction.type = action.onResponse;
    if (response && response.constructor === Array) {
      newAction.payload = response.map(function (item) {
        return item.data;
      });
    } else {
      newAction.payload = response.data;
    }
    store.dispatch(newAction);
  }
};

var dispatchOnError = exports.dispatchOnError = function dispatchOnError(_ref5) {
  var action = _ref5.action,
      store = _ref5.store,
      response = _ref5.response,
      method = _ref5.method;

  if (action.onError) {
    var newAction = createNewAction({ action: action, method: method });
    newAction.type = action.onError;
    newAction.payload = response.data;
    newAction.status = response.status;
    store.dispatch(newAction);
  }
};